## drmr 0+unstable

=== CMakeLists.txt ===
#CMake file for DrMr

cmake_minimum_required(VERSION 2.6)
project (DrMr)

set(LV2_INSTALL_DIR lib/lv2 CACHE PATH "Specifies where the LV2 libraries should be installed")
set(CMAKE_C_FLAGS "-Wall")

# Availble options
option(USE_NKNOB  "Use custom NKnob widgets for gain/pan instead of Gtk sliders" ON)
SET(SAMP_ZERO_POS "0" CACHE STRING "Default sample zero position 0=top left (tl) 1=bl 2=tr 3=br")

# check for our various libraries
find_package(PkgConfig)
pkg_check_modules(LV2 REQUIRED lv2>=0.1.0)
pkg_check_modules(SNDFILE REQUIRED sndfile>=1.0.20)
pkg_check_modules(SAMPLERATE REQUIRED samplerate>=0.1.5)
pkg_check_modules (GTK2 REQUIRED gtk+-2.0>=2.22.0)
find_package (EXPAT REQUIRED)

include_directories (${LV2_INCLUDE_DIRS} ${EXPAT_INCLUDE_DIRS} ${SNDFILE_INCLUDE_DIRS} ${SAMPLERATE_INCLUDE_DIRS} ${GTK2_INCLUDE_DIRS})
link_directories (${LV2_LIBRARY_DIRS} ${EXPAT_LIBRARY_DIRS} ${SNDFILE_LIBRARY_DIRS} ${SAMPLERATE_LIBRARY_DIRS} ${GTK2_LIBRARY_DIRS})

# config libraries

add_library(drmr SHARED
  drmr.c
  drmr_hydrogen.c
  drmr.h
  drmr_hydrogen.h
)

add_library(drmr_ui SHARED
  drmr_ui.c
  drmr_hydrogen.c
  nknob.c
  drmr_hydrogen.h
  nknob.h
)

set_target_properties(drmr PROPERTIES PREFIX "")
set_target_properties(drmr_ui PROPERTIES PREFIX "")
set_target_properties(drmr_ui 
  PROPERTIES
  LINK_FLAGS "-Wl,-znodelete"
)

target_link_libraries(drmr ${LV2_LIBRARIES} ${SNDFILE_LIBRARIES} ${SAMPLERATE_LIBRARIES} ${EXPAT_LIBRARIES} m)
target_link_libraries(drmr_ui ${LV2_LIBRARIES} ${GTK2_LIBRARIES} ${SNDFILE_LIBRARIES} ${SAMPLERATE_LIBRARIES} ${EXPAT_LIBRARIES} m)


add_definitions ( -DPIC )

set_target_properties (drmr
  PROPERTIES
  COMPILE_FLAGS "-std=gnu99"
)

set (ui_compile_flags "-std=gnu99")

if (NOT USE_NKNOB)
  set (ui_compile_flags "${ui_compile_flags} -DNO_NKNOB")
endif (NOT USE_NKNOB)

if (SAMP_ZERO_POS GREATER "-1" AND SAMP_ZERO_POS LESS "4")
   set (ui_compile_flags "${ui_compile_flags} -DDRMR_UI_ZERO_SAMP=${SAMP_ZERO_POS}")
else (SAMP_ZERO_POS GREATER "-1" AND SAMP_ZERO_POS LESS "4")
   message(WARNING "Invalid SAMP_ZERO_POS, defaulting to 0 \(top left\).  Valid values are 0,1,2,3")
   set (ui_compile_flags "${ui_compile_flags} -DDRMR_UI_ZERO_SAMP=0")
endif (SAMP_ZERO_POS GREATER "-1" AND SAMP_ZERO_POS LESS "4")

set_target_properties (drmr_ui
  PROPERTIES
  COMPILE_FLAGS ${ui_compile_flags}
)

# Custom test commands
add_executable ( htest
  EXCLUDE_FROM_ALL
  drmr_hydrogen.c
)

add_executable ( knobt
  EXCLUDE_FROM_ALL
  nknob.c
)

# config test executables
target_link_libraries(htest ${LV2_LIBRARIES} ${GTK2_LIBRARIES} ${SNDFILE_LIBRARIES} ${SAMPLERATE_LIBRARIES} ${EXPAT_LIBRARIES} m)
set_target_properties ( htest
  PROPERTIES
  COMPILE_FLAGS "-D_TEST_HYDROGEN_PARSER"
)
target_link_libraries(knobt ${LV2_LIBRARIES} ${GTK2_LIBRARIES} ${SNDFILE_LIBRARIES} ${SAMPLERATE_LIBRARIES} ${EXPAT_LIBRARIES} m)
set_target_properties ( knobt
  PROPERTIES
  COMPILE_FLAGS "-D_TEST_N_KNOB"
)

# config install
install(TARGETS drmr drmr_ui
  LIBRARY
  DESTINATION ${CMAKE_INSTALL_PREFIX}/${LV2_INSTALL_DIR}/drmr.lv2
)

install (FILES manifest.ttl drmr.ttl knob.png led_on.png led_off.png
  DESTINATION ${CMAKE_INSTALL_PREFIX}/${LV2_INSTALL_DIR}/drmr.lv2
)

=== debian/changelog ===
drmr (1:0+unstable-1kxstudio2) lucid; urgency=medium

  * Update to latest git "unstable" version

 -- falkTX <falktx@gmail.com>  Fri, 21 Mar 2014 17:26:00 +0000

drmr (0-0kxstudio1) lucid; urgency=low

  * Initial release

 -- falkTX <falktx@gmail.com>  Sun, 18 Aug 2013 02:24:46 +0100

=== debian/control ===
Source: drmr
Section: sound
Priority: extra
Maintainer: Jeremy Jongepier <jeremy@autostatic.com>
Build-Depends: debhelper (>= 8.0.0),
 cmake,
 pkg-config,
 libgtk2.0-dev,
 lv2-dev,
 libsndfile-static,
 libsamplerate-static
Standards-Version: 3.9.3
Homepage: https://github.com/nicklan/drmr
#Vcs-Git: git://git.debian.org/collab-maint/drmr.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/drmr.git;a=summary

Package: drmr
Architecture: any
Depends: ${misc:Depends}
Description: drmr
 DrMr is an LV2 sampler plugin.
 It's main reason to exist is to give a way for lv2 hosts to have a built-in
 drum synth that can save its entire state (i.e. no need to go out to external tools
 and no need to save extra state).
 .
 DrMr currently supports the following:
 - Control via midi
 - Scan for and load hydrogen drum kits (see note 2)
 - Multi-layer hydrogen kits (will pick layer based on that samples set gain)
 - LV2 controls for gain on first 32 samples of kit (see note 1 below)
 - LV2 controls for pan on first 32 samples of kit (see note 1 below)
 - GTK ui that can select a kit and control gain/pan on each sample
 - Custom knob widget for GTK ui based on phatknob that is both functional and awesome looking. (see wiki for screenshot)
 - Sample grid can start in any corner of the window, to match the layout of your controller.

=== debian/rules ===
#!/usr/bin/make -f

FLAGS=-g -O2 -pipe -ffast-math -mtune=generic -msse -msse2 -mfpmath=sse -fPIC -DPIC -fstack-protector --param=ssp-buffer-size=4 -D_FORTIFY_SOURCE=2

export CFLAGS=$(FLAGS)
export CXXFLAGS=$(FLAGS)
export LDFLAGS=-Wl,-O1 -Wl,-Bsymbolic-functions -Wl,--strip-all -Wl,-z,relro,-z,now -Wl,--no-undefined

export PKG_CONFIG_PATH=/opt/kxstudio/lib/pkgconfig/

%:
	dh $@
